***********************************************
**** 2.1.do
***********************************************
**** This do file illustrates omitted variable
**** bias. It is intended to complement the 
**** discussion in Chapter 2.3 The ESTIMATION 
**** CHALLENGES: SOME COMMON ESTIMATORS
***********************************************
clear
* First the seed is set to a specific number.
* Below standard normal random variables are 
* drawn. Such pseudo-random number generation
* requires an initial seed number. The numbers 
* are pseudo-random because they are not in fact
* random but instead a deterministic function of the
* initial seed value.
set seed 0123456789

* Displaying the seed in the format in which
* STATA stores it.

display c(seed)

* setting the observations to 300

set obs 30000

* drawing the key variables from 
* a pseudo-random standard normal
* distribution

generate ex=5*invnorm(uniform())

generate e=5*invnorm(uniform())

generate P=(2*invnorm(uniform())>0)

* summary statistics

ta P


gen x=1+P+ex


* Summary statistics for the errors and regressors
summarize e P x

* Correlations between errors and regressors
correlate e P x


generate y=1-.5*P+1.5*x+e

* the regressions

* Regressing y on P and x
regress y P x


local a=_b[P]

local b=_b[x]


* Regressing y on x1 alone
regress y P


* Regressing x on P
regress x P


local c=_b[P]

di `a'+`b'*`c'

regress y P

predict yhat

generate err=y-yhat

* demonstrating that P is uncorrelated with the 
* predicted errors from the "wrong" regression 
* ( of y on x1 alone)

correlate P err

generate err2=1.5*x+e

* demonstrating that P is correlated with the 
* true regression error for the ``wrong'' model

correlate P err2

correlate P e


