***********************************************
**** 4.1.do
***********************************************
**** This do file illustrates omitted variable
**** bias. It is intended to complement the 
**** discussion in Chapter 4.1 of regression basics
**** and multiple regression
**** This begins much as the 2.1_display.do
***********************************************
clear
* First the seed is set to a specific number.
* Below standard normal random variables are 
* drawn. Such pseudo-random number generation
* requires an initial seed number. The numbers 
* are pseudo-random because they are not in fact
* random but instead a deterministic function of the
* initial seed value.
set seed 2468

* Displaying the seed in the format in which
* STATA stores it.

display c(seed)

* setting the observations to 300

set obs 30000

* drawing the key variables from 
* a pseudo-random standard normal
* distribution

generate x=2*invnorm(uniform())

generate e=5*invnorm(uniform())

generate eP=6*invnorm(uniform())

generate P=((.5*x+eP)>0)

* summary statistics

ta P


sjlog using C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_a

* Summary statistics for the errors and regressors
summarize e eP x P

* Correlations between errors and regressors
correlate e eP x P

sjlog close

sjlog type C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_a.log.tex


generate Y=1+.5*P+1.5*x+e

* the regressions


sjlog using C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_b

* Regressing y on P and x
regress Y P x

sjlog close

sjlog type C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_b.log.tex


local a=_b[P]

local b=_b[x]

sjlog using C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_c

* Regressing y on P alone
regress Y P

sjlog close

sjlog type C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_c.log.tex

sjlog using C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_d

* Regressing x on P
regress x P

sjlog close

sjlog type C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\4\4.1\logs\4.1_d.log.tex

local c=_b[P]

di `a'+`b'*`c'

regress Y P

predict Yhat

generate err=Y-Yhat

* demonstrating that P is uncorrelated with the 
* predicted errors from the "wrong" regression 
* ( of y on x1 alone)

correlate P err

generate err2=1.5*x+e

* demonstrating that P is correlated with the 
* true regression error for the ``wrong'' model

correlate P err2

correlate P e


