***********************************************
**** 4.2.do
***********************************************
**** This do file illustrates omitted variable
**** bias in the logit setting. It is intended to complement the 
**** discussion in Chapter 4.1 of regression basics
**** and multiple regression
**** This is essentially a slight twist on 4.1.do
***********************************************
clear
* First the seed is set to a specific number.
* Below standard normal random variables are 
* drawn. Such pseudo-random number generation
* requires an initial seed number. The numbers 
* are pseudo-random because they are not in fact
* random but instead a deterministic function of the
* initial seed value.
set seed 2468

* Displaying the seed in the format in which
* STATA stores it.

display c(seed)

* setting the observations to 300

set obs 30000

* drawing the key variables from 
* a pseudo-random standard normal
* distribution

generate x=2*invnorm(uniform())

generate e=5*invnorm(uniform())

generate eP=6*invnorm(uniform())

generate P=((.5*x+eP)>0)

* summary statistics

ta P


generate Y=1+.5*P+1.5*x+e

replace Y=(Y>0)

tab Y

generate Ysim0=1 +1.5*x+e

generate Ysim1=1+.5+1.5*x+e



* The binary outcome
tab Y


* the regressions

reg Y P x


* Linear Regression y on P and x
reg Y P x


* Logit regressing y on P and x
logit Y P x


g Pt=P

replace P=0

predict p0

replace P=1

predict p1

g mx=p1-p0

su mx

drop p0 p1 mx

replace P=Pt



* Logit regressing y on P alone
logit Y P


replace P=0

predict p0

replace P=1

predict p1

g mx=p1-p0

su mx

drop p0 p1 mx

replace P=Pt

