***********************************************
**** 4.3.do
***********************************************
**** This do file illustrates omitted variable
**** bias in the multiple confounder setting.
**** It is also used to illustrate the regression
**** anatomy formula. 
**** It is intended to complement the 
**** discussion in Chapter 4.1 of regression basics
**** and multiple regression
***********************************************
clear
set seed 2468

display c(seed)

* setting the observations to 30000

set obs 50000

* drawing the key variables from 
* a pseudo-random standard normal
* distribution

local i=1
while (`i'<6){
generate x`i'=2*invnorm(uniform())
loc i=`i'+1
}

generate e=5*invnorm(uniform())

generate eP=12*invnorm(uniform())

generate P=((-.5*x1+x2-1.5*x3+2*x4+4*x5+eP)>0)

* summary statistics

ta P


* Summary statistics for the errors and regressors
summarize e eP x* P

* Correlations between errors and regressors
correlate e eP x* P



generate Y=1+.5*P+1.5*x1+1.3*x2+.5*x3+x4-.5*x5+e


* Regressing Y on P and x1-x5

reg Y P x*


* Regressing Y on just P and x2, x4, x5

reg Y P x2 x4 x5


* Regressing Y on just P and x1, x3, x5

reg Y P x1 x3 x5


* Regressing P on x1-x5

reg P x*


predict Phat

gen PRES=P-Phat


* Regressing Y on "Residual P"

reg Y PRES



