***********************************************
**** 4.4.do
***********************************************
**** This do file that illustrates the bad control
**** problem. It begins with the Angrist and Krueger
**** case, and ends with the broader case.
***********************************************
clear
set seed 2468

display c(seed)

* setting the observations to 30000

set obs 50000

* Determining Program Participation
* Notice that P is randomized
g P=(invnorm(uniform())>0)

loc corr1=.3
matrix C = (1, `corr1' \ `corr1', 1)
drawnorm ey ex, corr(C)
corr P ey ex

* setting up outcome of interest
  loc yx=1.5
* loc yx=0
replace ey=4*ey
g Y_0=1+ey
g Y_1=3+ey
g Yret=Y_1-Y_0
sum Yret
sum Yret if P==1
g Y=P*Y_1+(1-P)*Y_0
reg Y P

* setting up "other outcome"
replace ex=4*ex
g X_0=1+ex
g X_1=4+ex
g Xret=X_1-X_0
sum Xret
sum Xret if P==1
g X=P*X_1+(1-P)*X_0
reg X P

reg Y P



corr P ey


reg Y P X





* easiest way to look at this is with "regression anatomy formula" (p. 35-36 of Angrist and Pischke)

corr P X
reg P X



predict Phat
g PRES=P-Phat

reg Y P X
reg Y PRES



corr P ex X
corr PRES ex X

corr P ey ex X 
corr PRES ey ex X


clear

set seed 2468

display c(seed)

* setting the observations to 30000

set obs 50000

* drawing mu1 and mu2     
loc corr1=.5   
matrix C1 = (1,       `corr1' \ ///    
          `corr1',      1 )
drawnorm mu1 mu2, corr(C1)
corr mu1 mu2 

* drawing ex and eY     
loc corr2=.5  
matrix C2 = (1,       `corr2' \ ///    
          `corr2',      1 )
drawnorm ex ey, corr(C2)
corr mu1 mu2 ex ey


* setting up P

g P=(mu1>0)


* setting up outcome of interest
replace ey=4*ey
g Y_0=1+ey
g Y_1=3+ey
g Yret=Y_1-Y_0
sum Yret
sum Yret if P==1
g Y=P*Y_1+(1-P)*Y_0

reg Y P




g X=mu2+ex

corr Y X

corr ey X

reg Y P X




* easiest way to look at this is with "regression anatomy formula" (p. 35-36 of Angrist and Pischke)
corr P X
reg P X
predict Phat
g PRES=P-Phat

reg Y PRES



corr P ey
corr PRES ey

corr P ey
corr PRES ey




