***********************************************
**** 5.2.do
***********************************************
**** This do file illustrates the basic difference
**** in differences estimator
***********************************************
* log using "C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\5\5.2\logs\log.log", replace
clear
clear matrix 
clear mata
set maxvar 5500
set matsize 5500
set mo off

set seed 2468
loc T=2
display c(seed)

* setting the observations to 300

set obs 20000

* drawing an individual ID variable

g ID=_n

* drawing the key variables from 
* a pseudo-random standard normal
* distribution

generate x_0=1

generate x_1=2*invnorm(uniform())

generate mu=2*invnorm(uniform())

* creating 2 observations per person

expand `T'

* new number of observations

di _N

by ID, sort: generate t=_n
generate epsilony=3*invnorm(uniform())
generate epsilonc=3*invnorm(uniform())

loc y10=6
loc y11=2.5
loc y1t=1
loc y00=4
loc y01=2.5
loc y0t=1
loc c0=1
loc c1=-2.5
g z=1
g y0=mu+epsilony
g y1=mu+epsilony
g c=-2*mu+epsilonc
loc j=0
while (`j'<2){
replace y0=y0+`y0`j''*x_`j'
replace y1=y1+`y1`j''*x_`j'
replace c=c+`c`j''*x_`j'
loc j=`j'+1
}
replace y0=y0+`y0t'*t
replace y1=y1+`y1t'*t

g Ptemp=(y1-y0-c>0)
replace Ptemp=0 if t==1
by ID, sort: egen XP=sum(Ptemp)
g P=. 
replace P=1 if XP>0
replace P=0 if XP==0

g TE=y1-y0
su TE if t==2

g Y=.
replace Y=y0 if t==1

replace Y=P*y1+(1-P)*y0 if t==2

by t P, sort: su Y y1 y0 x_1 mu

by P, sort: su Y if t==1

by P, sort: su Y if t==2











* Basic summary statistics: participation
by t, sort: tab P

* Basic summary statistics
by t P, sort: summarize Y y1 y0 c x_1 mu epsilon*



* Basic summary statistics
by t, sort: summarize Y 



* Basic IE estimate and DID estimate
mean Y if P==1&t==2
loc YP2=_b[Y]
mean Y if P==1&t==1
loc YP1=_b[Y]
mean Y if P==0&t==2
loc YN2=_b[Y]
mean Y if P==0&t==1
loc YN1=_b[Y]
loc basic=`YP2'-`YN2'
di `basic'
loc DID=`YP2'- `YP1' - (`YN2'-`YN1')
di `DID'


* Basic IE regression

reg Y P if t==2


* Basic IE multiple regression

reg Y P x_1 if t==2


* Basic DID regression

g dt=t-1
ta dt

g Pdt=P*dt

reg Y P dt Pdt 

