***********************************************
**** 6.3.do
***********************************************
**** This do file illustrates LATE
***********************************************
* log using "C:\program_evaluation\survey_paper\Paper\Dec12\STATA_do_files\6\6.2\logs\log.log", replace
clear
clear matrix 
clear mata

set mo off

set seed 2468
display c(seed)

set obs 50000



* drawing the key variables from 
* a pseudo-random standard normal
* distribution
generate x0=1
generate x=2*invnorm(uniform())
generate z=(invnorm(uniform())>0)
generate mu=2*invnorm(uniform())
generate epsilony=3*invnorm(uniform())
generate epsilonc=3*invnorm(uniform())

generate omega=4*uniform()
generate betaYP=omega
generate betaPz=-1.4*omega

loc y10=4
loc y11=1.5
loc y00=2
loc y01=1.5
loc c0=5.5
loc c1=2
loc c2=-.5
loc c3=.5
g y0=mu+epsilony
g y1=mu+epsilony

replace y0=y0+`y00'*x0
replace y1=y1+`y00'+betaYP*x0
replace y0=y0+`y01'*x
replace y1=y1+`y11'*x

g c=mu+epsilonc
replace c=c+`c0'*x0
replace c=c+`c1'*x
replace c=c+betaPz*z

g c0=mu+epsilonc
replace c0=c0+`c0'*x0
replace c0=c0+`c1'*x
replace c0=c0+0

g c1=mu+epsilonc
replace c1=c1+`c0'*x0
replace c1=c1+`c1'*x
replace c1=c1+betaPz

g P=(y1-y0-c>0)

g P0=(y1-y0-c0>0)

g P1=(y1-y0-c1>0)

g comp=(P0==0&P1==1)
ta comp
g problem=(P0==1&P1==0)
ta problem
g always=(P0==1&P1==1)
ta always
g never=(P0==0&P1==0)
ta never





g Y=P*y1+(1-P)*y0

ivreg Y x (P=x z), first



su x if comp==1
su x if never==1
su x if always==1


* Basic summary statistics: participation
tabulate P


* Basic summary statistics: variable means

by P, sort: summarize Y y1 y0 c x* z* mu epsilon*


* Correlations among unobservables

correlate P z* mu epsilony epsilonc omega


* Average program impact

generate TE=y1-y0
summarize TE


* Cross sectional regression

regress Y x P

* The average treatment effect for compliers
summarize TE if comp==1
* The average treatment effect for the never takers
summarize TE if never==1
* The average treatment effect for the always takers
summarize TE if always==1




ivregress 2sls Y x (P=x z), first



tabulate comp
generate zt=z
logit P x z
replace z=0
predict p0
replace z=1
predict p1
generate mx=p1-p0
su mx

drop p1 p0 mx

ta comp if P==1


logit P x z

replace z=0

predict p0

replace z=1

predict p1

g mx=p1-p0

sum mx

loc a=r(mean)

replace z=zt

mean z

loc b=_b[z]

mean P

loc c=_b[P]

di (`a'*`b'/`c')


su x

su x if comp==1



logit z x

predict pz

g k=1-(P*(1-z))/(1-pz) - ((1-P)*z)/pz

g kx=k*x

su k

loc a=r(mean)

su kx

loc b=r(mean)

di `b'/`a'

