***********************************************
**** 6.4.do
***********************************************
**** This do file illustrates the sharp 
**** discontinuity design
***********************************************
clear
set seed 123456789
set obs 10000
g x=invnorm(uniform())
g mu=invnorm(uniform())
g elig=(x<=0)
g ey=invnorm(uniform())
g y1=13+2.5*x+mu+ey
g y0=2+2.5*x+mu+ey
g ATE=y1-y0
su ATE
g ec=invnorm(uniform())
g C=1+100*(1-elig)-1.5*x - mu + ec
g Ct=1-2*x - mu + ec
g ret=y1-y0-Ct
su ret
g P=(y1-y0-C>0)
ta P
by elig, sort: ta P
g Y=P*y1+(1-P)*y0
reg Y P
reg Y P x


* Basic summary statistics: participation and eligibility
tabulate P

tabulate elig

tabulate P elig


* Summary statistics

by P, sort: summarize x mu Y y1 y0 C  Ct elig ey ec


* Cost and ATE

summarize ret ATE


* Key correlations

corr P elig x mu


* basic regression of Y on P

reg Y P


* basic regression of Y on eligibility

reg Y elig


* basic regression of Y on P and x

reg Y P x


predict Yhat

keep Y Yhat x

* xmlsave "C:\program_evaluation\survey_paper\Paper\Dec13\STATA_do_files\6\6.4\logs\x.xml", doc(excel)
