***********************************************
**** 6.7.do
***********************************************
**** This do file illustrates LATE in the "fuzzy"
**** RD design context
***********************************************
set seed 123
clear

loc thresh=.3
loc threshcost=5
set obs 1000000
g x=invnorm(uniform())
g elig=(x<=`thresh')
g mu=invnorm(uniform())
g ey=3*invnorm(uniform())
g w=15*uniform()
* replace w=0
g y1=5+w-2*x+7*mu + ey
g y0=1-2*x+7*mu + ey
g ec=4*invnorm(uniform())
g C=2+x + `threshcost'*(1-elig) + 3*mu + ec
g ATE=y1-y0
su ATE
reg ATE x
g P=(y1-y0-C>0)
ta P
by elig, sort: ta P
reg P x elig
g Pelig=(y1-y0-(2+x+3*mu+ec)>0)
g Pinelig=(y1-y0-(2+x+`threshcost'+3*mu+ec)>0)
ta Pelig Pinelig
g complier=(Pelig==1&Pinelig==0)
ta complier
su ATE if complier==1
g Y=P*y1+(1-P)*y0

ivreg Y x (P=x elig), first
su ATE
su ATE if complier==1
reg Y P x


* Basic summary statistics: participation and eligibility
summarize P elig

by elig, sort: su P


* Summary statistics

by P, sort: summarize x mu Y y1 y0 C  elig ey ec



* Key correlations

corr P elig x mu


* ATE, whole sample 

summarize ATE

* ATE, compliers

summarize ATE if complier==1


reg Y P x


ivreg Y x (P=elig x), first

